=== debian/changelog ===
elastix (4.7-2) unstable; urgency=medium

  * Build-Depends: libfftw3-dev
    Closes: #746089

 -- Andreas Tille <tille@debian.org>  Sun, 27 Apr 2014 17:54:59 +0200

elastix (4.7-1) unstable; urgency=medium

  [ Gert Wollny ]
  * New upstream version
  * Add --as-needed to the linker flags
  * remove patches/disable-mevisdicomtiff.patch, fixed upstream (91edb5)
  * remove patches/itk-review-detection.patch, fixed upstream (9442a2)
  * Add patch to disable google-adsense in the created documentation  

  [ Andreas Tille ]
  * cme fix dpkg-control
  * Provide doc-base file

 -- Gert Wollny <gw.fossdev@gmail.com>  Tue, 11 Mar 2014 11:32:25 +0100

elastix (4.6-2) unstable; urgency=low

  * patches/itk-review-detection.patch: New.  Update ITK "Review module"
    detection to be compatible with ITK 4.5.
  * control: Tighten ITK build dep to be 4.5.0-2 because -1 omitted the
    review module.  Add libdcmtk2-dev, now required by ITK.

 -- Steve M. Robbins <smr@debian.org>  Sat, 04 Jan 2014 17:48:12 -0600

elastix (4.6-1) unstable; urgency=low

  * New upstream version.
  * control: Build-depend on libinsighttoolkit4-dev (instead of ITK 3).
  * control(elastix): Build only architectures amd64 and i386, following ITK 4.

  * patches/disable-mevisdicomtiff.patch: New.  Fix build system to honour
    ELASTIX_USE_MEVISDICOMTIFF=false
  * rules: Build with ELASTIX_USE_MEVISDICOMTIFF=false.
  
  * control: Add build-dep-indep on texlive-fonts-recommended to build
    docs.  Remove build-dep on libgdcm2-dev.  Closes: #731921.

 -- Steve M. Robbins <smr@debian.org>  Fri, 13 Dec 2013 23:26:15 -0600
